global save_return 

button .control_panel.save \
       -command {
           .control_panel.save configure -state disabled 
           save_model 
           .control_panel.save configure -state normal} \
       -text "Save Model" -font button_font

pack .control_panel.save

send_environment_cmd \
  "create list-handler .control_panel.save save_return (lambda (x)) ()"

bind .control_panel.save <Destroy> {
  remove_handler %W
}

proc save_model {} {
  
  
  global model_file_names
  global model_file_changed
  global current_open_model
  global options_array
  global save_return
  global tutor_mode
  global tutor_windows

  if {$current_open_model == ""} {
    tk_messageBox -icon warning -type ok -title "Saving model" \
                  -message "No model open."
  } else {
    if $tutor_mode {
      foreach x {.chunk_type .chunk .production .misc .command} {
        if {[winfo exists $x] == 1} {
          save_text $x.frame.text $model_file_names($x.frame.text)
          set model_file_changed($x.frame.text) 0
        }
      }

      save_backup

      # build the main file simply because the tutor models are simple...
         
      write_data "" $current_open_model

      if {[lsearch -exact $tutor_windows "misc"] != -1} {
        append_data [read_file $model_file_names(.misc.frame.text)] \
          $current_open_model
      }

      append_data "(clear-all)\n(pm-reset)\n" $current_open_model

      if {[lsearch -exact $tutor_windows "chunk_type"] != -1} {
        append_data [read_file $model_file_names(.chunk_type.frame.text)] \
                 $current_open_model
      }
      if {[lsearch -exact $tutor_windows "chunk"] != -1} {
        append_data [read_file $model_file_names(.chunk.frame.text)] \
                 $current_open_model
      }
      if {[lsearch -exact $tutor_windows "production"] != -1} {
        append_data [read_file $model_file_names(.production.frame.text)] \
                 $current_open_model
      }
      if {[lsearch -exact $tutor_windows "command"] != -1} {
      append_data [read_file $model_file_names(.command.frame.text)] \
                 $current_open_model
      }

      return 1

    } elseif {$options_array(open_as_split) == 1} {
      foreach x {.chunk_type .chunk .production .misc .command} {
        if {[winfo exists $x] == 1} {
          save_text $x.frame.text $model_file_names($x.frame.text)
          set model_file_changed($x.frame.text) 0
        }
      }

      save_backup

      # build the main file crudely incase there's an error
      # at least everything will be there
         
      write_data [read_file $model_file_names(.misc.frame.text)] \
                 $current_open_model
      append_data "(clear-all)\n(pm-reset)\n" $current_open_model
      append_data [read_file $model_file_names(.chunk_type.frame.text)] \
                 $current_open_model
      append_data [read_file $model_file_names(.chunk.frame.text)] \
                 $current_open_model
      append_data [read_file $model_file_names(.production.frame.text)] \
                 $current_open_model
      append_data [read_file $model_file_names(.command.frame.text)] \
                 $current_open_model

      if {[check_connection] == 0} {
        #it's hooked up to Lisp so have it reorder the file

        set save_return ""

        send_environment_cmd \
          "update [get_handler_name .control_panel.save] \
             (lambda (x) \
                (write-model-from-parts \"$current_open_model\"))"

        wait_for_non_null save_return

        # report_status $save_return

        if {[lindex $save_return 0] == 0} {
          tk_messageBox -icon error -type ok -title "Error In Model" \
                        -message "There are errors in the following windows:\
                        [lindex $save_return 1]"
          return 0
        } else {
          foreach x {.chunk_type .chunk .production .misc .command} {
            if {[winfo exists $x] == 1} {
              edit_model_file $x $model_file_names($x.frame.text) 1
            }
          }
          return 1
        }
      } else {
        tk_messageBox -icon warning -type ok -title "Close without Lisp" \
                        -message "Open models should be closed before\
                                  disconnecting from Lisp.  The file may\
                                  be slightly out of order, but will be\
                                  corrected the next time it's opened in\
                                  the environment - be careful if you use\
                                  it before then."

        return 1
      }
    } else {
      save_backup

      if {[winfo exists .model] == 1} {
        save_text .model.frame.text $model_file_names(.model.frame.text)
        set model_file_changed(.model.frame.text) 0
       return 1
      }
    }
  }
}

proc save_backup {} {
global current_open_model
global options_array

 
 
 if $options_array(save_backups) {
 
   set save_index 0
   
   while {[file exists "$current_open_model-$save_index"] == 1} {

     incr save_index

        }
       
     # report_status "'$current_open_model-$save_index' "
     write_data [read_file $current_open_model] \
                 "$current_open_model-$save_index"
  }
}
