global close_return 

button .control_panel.close -command {close_model} \
                            -text "Close Model" -font button_font

pack .control_panel.close

proc close_model {} {
  global current_open_model
  global current_open_model_name
  global options_array 
  global model_file_names

  if {$current_open_model == ""} {
    tk_messageBox -icon warning -type ok -title "Closing model" \
                  -message "No open model to close."
  } else {
    if {[save_model] == 0} {
      set answer [tk_messageBox -icon warning -type yesno \
                                -title "Closing model" \
                                -message "Close model even with the error(s)?."]

      if {$answer == "no"} {
        return 0
      }
    } 
          
    if {$options_array(open_as_split) == 1} {
      foreach x {.chunk_type .chunk .production .misc .command} {
        if {[winfo exists $x] == 1} {
          destroy $x
          set model_file_names($x.frame.text) ""
        }
      }
    } else {
      if {[winfo exists .model] == 1} {
        destroy .model
        set model_file_names(.model.frame.text) ""
      }
    }

    set current_open_model ""
    set current_open_model_name "No Model Open"

    if {[winfo exists .model_manager] == 1} {
     destroy .model_manager
    }

    return 1
  } 
} 
  
