global current_scale
global trace_return_value



proc select_graphic_trace {} {
global current_scale
global trace_return_value

  if {[winfo exists .graphic_trace] == 1} {
    wm deiconify .graphic_trace
    raise .graphic_trace
  } else {
    # make it now

    toplevel .graphic_trace
    wm withdraw .graphic_trace
    wm title .graphic_trace "Graphic Trace"

    wm geometry .graphic_trace [get_configuration .graphic_trace]

     
    send_environment_cmd \
      "create simple-handler .graphic_trace ignore_returns \
         graphic-trace-recorder (step reset)"

    bind .graphic_trace <Destroy> {remove_handler .graphic_trace}


    frame .graphic_trace.frame -borderwidth 0  
    
    canvas .graphic_trace.frame.canvas  \
         -xscrollcommand ".graphic_trace.frame.scrl set" \
         -width 2000 -height 400 -scrollregion {-4 0 2000 400} 
          
    scrollbar .graphic_trace.frame.scrl \
              -command ".graphic_trace.frame.canvas xview" -orient horizontal

    set current_scale 1.0


    canvas .graphic_trace.canvas1  \
         -width 150 -height 400 

    set y 35

    foreach label {Retrieval Goal Production Visual-Location Visual Manual Device} {
      .graphic_trace.frame.canvas create text -145 $y -anchor nw -font text_font -justify right -text $label -width 140
      .graphic_trace.canvas1 create text 5 $y -anchor nw -font text_font -justify right -text $label -width 140
      incr y 50
    }


    button .graphic_trace.start_gt \
       -command {
         send_environment_cmd "update [get_handler_name .graphic_trace.start_gt]"
         .graphic_trace.frame.canvas delete trace_items
    
         set .graphic_trace.textvar "Ready"   
    } -text "Start Recording" -font button_font

    send_environment_cmd \
      "create simple-handler .graphic_trace.start_gt ignore_returns \
         clear-trace-record ()"

    bind .graphic_trace.start_gt <Destroy> {remove_handler .graphic_trace.start_gt}

    label .graphic_trace.text -font text_font  -textvariable .graphic_trace.textvar
  
    set .graphic_trace.textvar ""
    
     button .graphic_trace.stop_gt \
      -command { .graphic_trace.frame.canvas delete trace_items
                 
                 set done 0

                 set .graphic_trace.textvar "Busy"
                 
                 while {$done == 0} {
                  set trace_return_value ""
                  
                  send_environment_cmd "update [get_handler_name .graphic_trace.stop_gt]"

                   wait_for_non_null trace_return_value

                 # report_status "{[lindex $trace_return_value 0] $done}"

                 switch [lindex $trace_return_value 0] {
                 finished {set done 1
                           
                 }
                 size { .graphic_trace.frame.canvas configure -width [lindex  $trace_return_value 2]
                 .graphic_trace.frame.canvas configure -scrollregion "-4 0 [expr 1 + [lindex $trace_return_value 2]] 400"
                 set size [lindex  $trace_return_value 2]

                  set x 0

                  while {$x < $size} {
                   .graphic_trace.frame.canvas create line $x 0 $x 400 -width 1 -f white -tag trace_items
                   .graphic_trace.frame.canvas create text $x 400 -text $x -anchor sw -font graphic_trace_font -tag trace_items
                   incr x 50
                 }



                 set current_scale 1.0
                 }
                 rectangle {
                 eval ".graphic_trace.frame.canvas create [lrange $trace_return_value 0 4] -width 1 -fill green -outline black -tag trace_items"
                 if {[expr [lindex $trace_return_value 3] - [lindex $trace_return_value 1]] != 0} {
                   eval ".graphic_trace.frame.canvas create text [lrange $trace_return_value 1 2] -text [lindex $trace_return_value 5] -anchor nw -font graphic_trace_font -tag {trace_items trace_text} -width [expr [lindex $trace_return_value 3] - [lindex $trace_return_value 1]]"
                 }
                 }
                 line {
                 eval ".graphic_trace.frame.canvas create [lrange $trace_return_value 0 6] -width 2 -smooth 1 -tag trace_items -fill black"
                 }
                }

                 
                 }

                  

                 set .graphic_trace.textvar "Done"
     } -text "Display" -font button_font

    send_environment_cmd \
      "create list-handler .graphic_trace.stop_gt trace_return_value \
         graphic-trace-return ()"

    bind .graphic_trace.stop_gt <Destroy> {remove_handler .graphic_trace.stop_gt}



     button .graphic_trace.zoom_in -command {

     if {$current_scale < 16} {
       set current_scale [expr 2 * $current_scale]
       .graphic_trace.frame.canvas scale trace_items 0 0 2.0 1.0
       .graphic_trace.frame.canvas configure -scrollregion "0 0 [expr 2 * [lindex [.graphic_trace.frame.canvas cget -scrollregion] 2]] 400"
       .graphic_trace.frame.canvas configure -width [expr 2 * [.graphic_trace.frame.canvas cget -width]]
      
     foreach x [.graphic_trace.frame.canvas find withtag trace_text] {
        .graphic_trace.frame.canvas itemconfigure $x -width \
            [expr 2 * [.graphic_trace.frame.canvas itemcget $x -width]]
     }
     }
     } \
     -text "+" -font button_font


     button .graphic_trace.zoom_out -command {

       set current_scale [expr .5 * $current_scale]
       .graphic_trace.frame.canvas scale trace_items 0 0 0.5 1.0
       .graphic_trace.frame.canvas configure -scrollregion "0 0 [expr .5 * [lindex [.graphic_trace.frame.canvas cget -scrollregion] 2]] 400"
       .graphic_trace.frame.canvas configure -width [expr .5 * [.graphic_trace.frame.canvas cget -width]]
       foreach x [.graphic_trace.frame.canvas find withtag trace_text] {
        .graphic_trace.frame.canvas itemconfigure $x -width \
            [expr .5 * [.graphic_trace.frame.canvas itemcget $x -width]]
     }
    

    } \
     -text "-" -font button_font
        

    button .graphic_trace.hide_text -command {

       .graphic_trace.frame.canvas delete trace_text
         } \
     -text "Remove Text" -font button_font
 
    
    pack .graphic_trace.frame.scrl -side bottom -fill x
    pack .graphic_trace.frame.canvas -side top -fill both 

    place .graphic_trace.frame -x 150 -y 0 -relwidth 1.0 -width -150 -relheight 1.0 -height -40
    place .graphic_trace.canvas1  -x 0 -y 0 -width 150 -relheight 1.0 -height -40
    
    place .graphic_trace.text -x 0 -width 150 -rely 1.0 -y -65
    place .graphic_trace.start_gt -x 0 -rely 1.0 -y -39 -relwidth .2 -height 38
    place .graphic_trace.stop_gt -relx .2 -rely 1.0 -y -39 -relwidth .2 -height 38
    place .graphic_trace.zoom_in -relx .4 -rely 1.0 -y -39 -relwidth .2 -height 38
    place .graphic_trace.zoom_out -relx .6 -rely 1.0 -y -39 -relwidth .2 -height 38
    place .graphic_trace.hide_text -relx .8 -rely 1.0 -y -39 -relwidth .2 -height 38



    # now show the window 

    wm deiconify .graphic_trace
}} 


button .control_panel.graphic_trace_button \
       -command {select_graphic_trace} -text "Graphic Trace" -font button_font

pack .control_panel.graphic_trace_button


proc save_graphic_trace {} {
  set fname [tk_getSaveFile -title "Save graphic trace as"\
                                  -filetypes {{"All Files" *}}]

  if {$fname != ""} {
    .graphic_trace.frame.canvas postscript -file $fname -width [.graphic_trace.frame.canvas cget -width] -height [.graphic_trace.frame.canvas cget -height] -rotate 1 -x -150 -y 0
  }
}

# env_instance eval {save_graphic_trace }